/* 
 * Copyright (c) 2011, 2016, Oracle and/or its affiliates. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; version 2 of the
 * License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */

#import "MSpinProgressCell.h"

@implementation MSpinProgressCell

- (void)setProgressIndicator:(NSProgressIndicator*)progress
{
  indicator = progress;
}

- (id)copyWithZone:(NSZone *)zone
{
  MSpinProgressCell *cell = (MSpinProgressCell*)[super copyWithZone: zone];
  cell->indicator = indicator;
  return cell;
}


- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
  if (!indicator || indicator.hidden)
    [super drawInteriorWithFrame: cellFrame inView: controlView];
  else 
  {
    if (indicator.superview == nil)
      [controlView addSubview: indicator];
    indicator.frame = cellFrame;
  }
}

- (NSProgressIndicator*)progressIndicator
{
  return indicator;
}
@end
